
//#include <graphics.h>
#include <math.h>
#include <stdlib.h>
//#include <dos.h>

//typedef enum {false, true} boolean;

#define WBC 5

#define X 200
#define Y 200


#define SIZE 2.
#define ZROTATE 11.
#define YROTATE 40.
#define XROTATE 0.




double function(double x, double y)
{
  double f;
    f = hypot(x, y) / 35.;
    if( fabs(f) < 1.e-5) return (40. * M_PI);
    else return (40. * sin(f * M_PI) / f);
}


void rotate3d(double xr, double yr, double zr, double *px, double *py, double *pz)
{
  double x = *px, y = *py, z = *pz;
  double x1, y1, z1, x2, y2, z2, x3, y3, z3;

  x1 = x * cos(zr) - y * sin(zr);
  y1 = x * sin(zr) + y * cos(zr);
  z1 = z;

  x2 = x1 * cos(yr) - z1 * sin(yr);
  y2 = y1;
  z2 = x1 * sin(yr) + z1 * cos(yr);

  x3 = x2;
  y3 = y2 * cos(xr) - z2 * sin(xr);
  z3 = y2 * sin(xr) + z2 * cos(xr);

  *px = x3;
  *py = y3;
  *pz = z3;
}


int getmaxx()
{
	return 100;
}

int getmaxy()
{
	return 100;
}

void moveto(HDC hdc, int xx, int yy)
{
	POINT pt;
	MoveToEx(hdc, xx, yy, &pt)
}

void lineto(HDC hdc, int xx, int yy)
{
	LineTo(hdc, xx, yy);
}

void graph(double y, double z, int *plotted)
{
  int xx, yy, xasp, yasp;

  xasp = 1;
  yasp = 1;
//  getaspectratio(&xasp, &yasp);
  xx = getmaxx() / 2 + (int) y;
  yy = getmaxy() / 2 - (int) (z * xasp / yasp);
  if(*plotted == false) moveto(xx, yy);
  else lineto(xx, yy);
  *plotted = true;
}



void fn_main(void)
{
//  int graphdrive = DETECT, graphmode;
  int plotted = false;
  double x, y, z, x2, y2, z2;
  double zr, yr, xr;
  double rd;
  char c;

//  initgraph(&graphdrive, &graphmode, "c:\\turboc3\\bgi");

  zr = ZROTATE * M_PI / 180.;
  yr = YROTATE * M_PI / 180.;
  xr = XROTATE * M_PI / 180.;

int const size=600;

//union REGS i,o;
//i.x.ax=1;
//int86(0x33,&i,&o);

//rd = (double)(int)o;

  for(x = -115.; x <= 115.; x += 5.)
  {
    rd = rand()%10;
    for(y = -115.; y <= 115.; y += 5.)
    {

      z = function(x, y);
      x2 = x * SIZE + rd;
      y2 = y * SIZE ;
      z2 = z * SIZE ;
      rotate3d(xr, yr, zr, &x2, &y2, &z2);
      graph(y2, z2, &plotted);
    }
    plotted = false;
  }

	if(kbhit()) {
	break;
	}

}


